Attribute VB_Name = "MTimer"
' rsTimer.dll
' Robert Schatz - 8/13/1998
' aolsux@fall0ut.com

Option Explicit

Private Declare Function SetTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long) As Long

Private Declare Sub MemCopy Lib "kernel32" Alias "RtlMoveMemory" (Dest As Any, Src As Any, ByVal cb&)

Private Timers As New Collection

Private Function TimerProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTime As Long) As Long
Dim Timer As CTimer, tmpTimer As CTimer
    ' Get Object Reference from Object Pointer
    MemCopy ByVal tmpTimer, CLng(Timers(CStr(idEvent))), 4&
    Set Timer = tmpTimer
    MemCopy ByVal tmpTimer, 0&, 4&
    Timer.RaiseTimerEvent
End Function

Public Sub StartTimer(Timer As CTimer)
    ' Add Timer to Collection of Enabled Timers
    Timer.TimerID = SetTimer(0&, 0&, Timer.Interval, AddressOf TimerProc)
    ' The Object Pointer is added to the Timers Collection
    ' instead of an actual object reference so that the reference
    ' count is not incremented.  If the user of the CTimer Class
    ' wanted to destroy a CTimer Object, they couldn't and the
    ' Terminate Event of the Class would never fire because a reference
    ' existed in the collection.  The TimerProc Function demonstrates
    ' how to get back an object reference from an object pointer.
    Timers.Add ObjPtr(Timer), CStr(Timer.TimerID)
End Sub

Public Sub EndTimer(Timer As CTimer)
    ' Remove Timer from Collection of Enabled Timers
    With Timer
        KillTimer 0&, .TimerID
        Timers.Remove CStr(.TimerID)
        .TimerID = 0
    End With
End Sub
