VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CTimer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_TimerID As Long ' Timer Identifier
Private m_Enabled As Boolean ' Enabled Property
Private m_Interval As Long ' Interval Property

Event Timer()

' RaiseTimerEvent and TimerID Properties are Friends
' so that only MTimer can use them and not the user of the DLL.
Friend Sub RaiseTimerEvent()
    RaiseEvent Timer
End Sub

Friend Property Get TimerID() As Long
    TimerID = m_TimerID
End Property

Friend Property Let TimerID(new_TimerID As Long)
    m_TimerID = new_TimerID
End Property

Property Get Enabled() As Boolean
    Enabled = m_Enabled
End Property

Property Let Enabled(new_Enabled As Boolean)
    If m_Enabled <> new_Enabled Then
        ' Value has changed
        If new_Enabled Then
            ' Enabling Timer
            ' Do not Start Timer if Interval = 0
            If Interval <> 0 Then
                StartTimer Me
                m_Enabled = True
            End If
        Else
            ' Disabling Timer
            EndTimer Me
            m_Enabled = False
        End If
    End If
End Property

Property Get Interval() As Long
    Interval = m_Interval
End Property

Property Let Interval(new_Interval As Long)
    ' Minimum Timer Interval is 0, Maximum = 65535
    If new_Interval < 0 Then
        new_Interval = 0
    ElseIf new_Interval > 65535 Then
        new_Interval = 65535
    End If
    m_Interval = new_Interval
    ' Disable Timer if Interval = 0
    If m_Enabled And m_Interval = 0 Then Me.Enabled = False
End Property

Private Sub Class_Terminate()
    ' Disable Timer
    If m_Enabled Then EndTimer Me
End Sub
